/*
    Copyright (C) by Christian Gosch.

    This file is part of w3server, a very small HTTP(-subset) server.

    w3server is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*!
 * \mainpage Documentation for the advanced client
 * \section intro Introduction
 *  This is the documentation for the client program. It is the 
 *  command line part of the HTML browser.
 *  The second part of the report can be found <a href="../../../../docs/report.html">here</a>.
 * \section make Building client
 *  \subsection need What you need
 *  <ul>
 *   <li>Linux or Solaris <br>
 *    (Tested with Linux 2.2.13 and libc6)</li>
 *   <li>pthread library</li>
 *   <li>gcc or similar compiler (tested with egcs 2.91-66)</li>
 *   <li>GNU make</li>
 *   <li>libfl (from the flex package)</li>
 *   <li>flex if you wish to remake the C-code for the lexical analyzers
 *    from the .lex files (usually not)</li>
 *   <li>GNU autoconf if you want to remake the configure scripts</li>
 *  </ul>
 *
 * \subsection build Building it
 *  There are few things to do: 
 *  <ul>
 *   <li>Change to the client directory </li>
 *   <li>Type <code>./configure</code> to configure the source for your system.
 *       If configure reports any error, the source will very likely not build 
 *       correctly. Please report bugs to the authors.</li>
 *   <li>Type <CODE>make</CODE> at the command prompt. This 
 *   should build the client executable in the client directory.<br>
 *   Optional: Call <CODE>make clean</CODE> to delete all object 
 *   files and auto-save
 *   files. <CODE>make stat</CODE> outputs a little code statistics.
 *   You need the <CODE>wc</CODE> program to use this.</li>
 *   <li>In the rare case you should want to rebuild the flex analyser, call <br>
 *       <code>flex -i img.lex</code> <br>
         in the source directory and then <br>
	 <code>make clean; make</code> <br>
	 in the client directory.
 *  </ul>
 * \section usage Usage
 *  The command line format to call <CODE>client</CODE> is: <br>
 * \subsection usageget For getting a HTML page
 *  <CODE>client get full-path-to-file destination-file port</CODE> <br>
 *  Where
 *   <ul>
 *    <li><CODE>full-path-to-file</CODE> is the full URI, like <br>
 *        <CODE>io.iupiter.universe/www/hund.html</CODE>. </li>
 *    <li><CODE>destination-file</CODE> is the local file where the 
 *        downloaded file is to be stored.</li>
 *    <li><CODE>port</CODE> is the port number the server is running on.
 *        Usually, this is 80.</li>
 *   </ul>
 *
 * \subsection usagemail For sending mail
 * <CODE>client mail mailfile</CODE> <br>
 * Where
 * <ul>
 *  <li><CODE>mailfile</CODE> is a filename of a file of the following format: <br>
 *    First line: Recipient <br>
 *    Second line: Sender <br>
 *    Third line: mailer <br>
 *    Fourth line: port number on which the mailer accepts connections <br>
 *    The following lines contain the mail body, including ALL headers the
 *    sender wants to be sent (including sender and recipient headers).
 *  </li>
 * </ul>
 *
 * \section cachestuff Downloaded Files
 * If you download a HTML file, for example www.animals.org/dog/cat/mouse.html,
 * it is stored in the given destination file AND in the cache subdirectory (which is specified in 
 * client/src/w3clientconfig.h). The HTML file is scanned for image tags and the corresponding images 
 * are downloaded and stored in the cache directory, in this example that could be <br>
 * cache/www.animals.org/pictures/dog.gif <br>
 * The HTML pages are stored flatly in cache/, e.g. as <br>
 * cache/www.animals.org_index.html <br>
 * The slashes are replaced by underscores. This CAN lead to clashes but that is 
 * neglected for this program. In a release version, another mechanism would have to be
 * used.
 */


